---
title: 'RTCDataChannel: error event'
slug: Web/API/RTCDataChannel/error_event
tags:
  - API
  - Connectivity
  - Data Channel
  - Error
  - Error Handling
  - Networking
  - RTCDataChannel
  - Reference
  - WebRTC
  - WebRTC API
  - channel
  - data
  - events
  - rtc
---
<p>{{APIRef("WebRTC")}}</p>

<p>A WebRTC {{domxref("RTCDataChannel.error_event", "error")}} event is sent to an {{domxref("RTCDataChannel")}} object's {{domxref("RTCDataChannel.onerror", "onerror")}} error handler when an error occurs on the data channel.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>Yes</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("RTCErrorEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{DOMxRef("RTCDataChannel.onerror", "onerror")}}</td>
  </tr>
 </tbody>
</table>

<p>The {{domxref("RTCErrorEvent")}} object provides details about the error that occurred; see that article for details.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">// Strings for each of the SCTP cause codes found in RFC
// 4960, section 3.3.10:
// https://tools.ietf.org/html/rfc4960#section-3.3.10

const sctpCauseCodes = [
  "No SCTP error",
  "Invalid stream identifier",
  "Missing mandatory parameter",
  "Stale cookie error",
  "Sender is out of resource (i.e., memory)",
  "Unable to resolve address",
  "Unrecognized SCTP chunk type received",
  "Invalid mandatory parameter",
  "Unrecognized parameters",
  "No user data (SCTP DATA chunk has no data)",
  "Cookie received while shutting down",
  "Restart of an association with new addresses",
  "User-initiated abort",
  "Protocol violation"
];

dc.addEventListener("error", ev =&gt; {
  const err = ev.error;

  console.error("WebRTC error: ", err.message);

  // Handle specific error detail types

  switch(err.errorDetail) {
    case "sdp-syntax-error":
      console.error("    SDP syntax error in line ", err.sdpLineNumber);
      break;
    case "idp-load-failure":
      console.error("    Identity provider load failure: HTTP error ",
                    err.httpRequestStatusCode);
      break;
    case "sctp-failure":
      if (err.sctpCauseCode &lt; sctpCauseCodes.length) {
        console.error("    SCTP failure: ", err.sctpCauseCode);
      } else {
        console.error("    Unknown SCTP error");
      }
      break;
    case "dtls-failure":
      if (err.receivedAlert) {
        console.error("    Received DLTS failure alert: ", err.receivedAlert);
      }
      if (err.sentAlert) {
        console.error("    Sent DLTS failure alert: ", err.receivedAlert);
      }
      break;
  }

  // Add source file name and line information

  console.error("    Error in file ", err.filename, " at line ", err.lineNumber,
                ", column ", err.columnNumber);
}, false);
</pre>

<p>The received event provides details in an {{domxref("RTCError")}} object called {{domxref("RTCErrorEvent.error", "error")}}; <code>RTCError</code> is an extension of the {{domxref("DOMException")}} interface. The error's {{domxref("DOMException.name", "name")}} is <code>RTCError</code> and the {{domxref("DOMException.message", "message")}} is an error string specified by the WebRTC layer.</p>

<p>Error information is output to the console using {{domxref("console.error()")}}. The <code>message</code> string is always output, as is information about the source file's name, line number, and column number at which the error occurred.</p>

<p>In addition, however, depending on the value of {{domxref("RTCError.errorDetail", "errorDetail")}}, additional information may be output. Each error type has a different set of information output. For example, an SDP syntax error displays the line number of the error within the SDP, and an SCTP error displays a message corresponding to the SCTP cause code. Other error types similarly output appropriate information.</p>

<p>You can also set up an event handler for <code>error</code> events using the <code>RTCDataChannel</code> interface's {{domxref("RTCDataChannel.onerror", "onerror")}} event handler property:</p>

<pre class="brush: js">dc.onerror = ev =&gt; {
  const err = ev.error;

  /* ... */
}</pre>

<div class="notecard note">
<p><strong>Note:</strong> Since <code>RTCError</code> is not one of the legacy errors, the value of {{domxref("DOMException.code", "RTCError.code")}} is always 0.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#event-datachannel-error', 'error event')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCDataChannel.error_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Simple_RTCDataChannel_sample">A simple RTCDataChannel example</a></li>
 <li>Related events: {{domxref("RTCDataChannel.open_event", "open")}}, {{domxref("RTCDataChannel.message_event", "message")}}, and {{domxref("RTCDataChannel.close_event", "close")}}</li>
</ul>
